namedRegExp = require('named-regexp').named

class RegExpResolver extends Object
  constructor:()->
    @patternCache = {}
    @attributeRe = /:([a-zA-Z][a-zA-Z0-9_]*)/g

  isMatch:(pattern,value)->
    return @namedRegExpForPattern(pattern).test(value)

  namedMatchesForPattern:(pattern,value)->
    match = @namedRegExpForPattern(pattern).exec(value)
    captures = {}
    for key,_ of match?.captures
      captures[key] = match.capture(key)
    return captures

  namedRegExpForPattern:(pattern)->
    re = @patternCache[pattern]
    if not re
      re = namedRegExp(new RegExp(pattern.replace(/\*/,'.*').replace(@attributeRe,'(:<$1>[^/]+)')))
      @patternCache[pattern] = re
    return re

  attributesForPattern:(pattern)->
    attrs = []
    while match = @attributeRe.exec(pattern)
      attrs.push(match[1])
    return attrs;

  replaceAttributesWithCurlyBracketsInPattern:(pattern,brackets = ['{{','}}'])->
    return pattern.replace(@attributeRe,brackets[0]+'$1'+brackets[1])


module.exports = RegExpResolver