var assert = require('assert');

var re = new (require('../RegExpResolver'))()

describe('tests',function(){
    it('should pass isMatch',function(){
        assert.ok(re.isMatch('[a-z]+[0-9]+','test1234'));
        assert.ok(re.isMatch('[a-z]+[0-9]+','test123498098'));
        assert.ok(!re.isMatch('[a-z]+[0-9]+&','test1234asd'));
    })
    it('should pass namedMatchesForPattern',function(){
        var matches = re.namedMatchesForPattern('/:var1/aa/:var2','/test/aa/test2');
        assert.ok(matches.var1,'test');
        assert.ok(matches.var2,'test2');

        var matches = re.namedMatchesForPattern('/:var1/aa/:var2','/test/aaa/test2');
        assert.equal(JSON.stringify(matches),'{}')
    })
    it('should pass attributesForPattern',function(){
        var attrs = re.attributesForPattern('/test/:attr1/blah/:attr2');
        assert.equal(JSON.stringify(attrs),'["attr1","attr2"]')
    })
    it('should pass replaceAttributesWithCurlyBracketsInPattern',function(){
        assert.equal(re.replaceAttributesWithCurlyBracketsInPattern('hello/:world'),'hello/{{world}}');
        assert.equal(re.replaceAttributesWithCurlyBracketsInPattern('hello/:world',['!!','??']),'hello/!!world??');
    })
})
